searchData={"items":[{"type":"module","title":"Benchee.Formatters.HTML","doc":"Functionality for converting Benchee benchmarking results to an HTML page\nwith plotly.js generated graphs and friends.","ref":"Benchee.Formatters.HTML.html"},{"type":"module","title":"Examples - Benchee.Formatters.HTML","doc":"list = Enum.to_list(1..10_000)\n    map_fun = fn(i) -> [i, i * i] end\n\n    Benchee.run(\n      %{\n        \"flat_map\" => fn -> Enum.flat_map(list, map_fun) end,\n        \"map.flatten\" => fn -> list |> Enum.map(map_fun) |> List.flatten() end\n      },\n      formatters: [\n        Benchee.Formatters.Console,\n        {Benchee.Formatters.HTML, file: \"samples_output/flat_map.html\"}\n      ]\n    )","ref":"Benchee.Formatters.HTML.html#module-examples"},{"type":"function","title":"Benchee.Formatters.HTML.format/2","doc":"Transforms the statistical results from benchmarking to html reports.\n\nReturns a map from file name/path to file content. This list is ready to be put into\n`Benchee.Utility.FileCreation.each/3`. It's a list of names to be \"interleaved\" with\na main file name that points to the contents of the file. For example:\n\n    %{[\"big list\", \"flat_map\"] => \"...file content...\"}","ref":"Benchee.Formatters.HTML.html#format/2"},{"type":"function","title":"Benchee.Formatters.HTML.write/2","doc":"Writes the output of `Benchee.Formatters.HTML.format/2` to disk.\n\nGenerates the following files:\n\n* index file (exactly like `file` is named)\n* a comparison of all the benchmarked jobs (one per benchmarked input)\n* for each job a detail page with more detailed run time graphs for that\n  particular job (one per benchmark input)","ref":"Benchee.Formatters.HTML.html#write/2"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"1.0.1 (2023-12-27) - Changelog","doc":"Just a small library updated I didn't want folks to miss.\n\n#","ref":"changelog.html#1-0-1-2023-12-27"},{"type":"extras","title":"Mini-Feature/Maitenance - Changelog","doc":"* Graphing library (plotly.js) updated, graphs may look slightly different.","ref":"changelog.html#mini-feature-maitenance"},{"type":"extras","title":"1.0.0 (2019-03-28) - Changelog","doc":"Compatibility with benchee 0.99.0 and 1.0.0 as well as benchee_json 1.0.0.","ref":"changelog.html#1-0-0-2019-03-28"},{"type":"extras","title":"0.6.0 (2019-02-10) - Changelog","doc":"#","ref":"changelog.html#0-6-0-2019-02-10"},{"type":"extras","title":"Features - Changelog","doc":"* benchee 0.14.0 support\n* added memory measurements with graphs and data tables","ref":"changelog.html#features"},{"type":"extras","title":"0.5.0 (2018-02-11) - Changelog","doc":"#","ref":"changelog.html#0-5-0-2018-02-11"},{"type":"extras","title":"Features - Changelog","doc":"* y-axis doesn't always start at 0 anymore for raw run times so that the space can be used\n* note benchee & html versions down in the footer\n* option to inline all assets `inline_assets`\n* Support for benche `0.12`'s tags and names that are now displayed correctly\n\n#","ref":"changelog.html#features"},{"type":"extras","title":"Bugfixes - Changelog","doc":"* Through a change in `benchee_json` formatter generation won't fail any longer if you're using `poison` < 3","ref":"changelog.html#bugfixes"},{"type":"extras","title":"0.4.0 (2017-10-24) - Changelog","doc":"#","ref":"changelog.html#0-4-0-2017-10-24"},{"type":"extras","title":"Features - Changelog","doc":"* Benchee 0.10.0 compatibility\n* uses the `unit_scaling` option from benchee and scales units accordingly\n* automatically open the report in a web browser after creation is finished\n* update plotly.js version\n* hide the save and edit in cloud link from plotly graphs\n* use a default file name so you don't HAVE to supply a file name\n* New \"System info\" link at the top right to display system information like OS, CPU, RAM etc.\n* You can now specify the formatter as just `Benchee.Formatters.HTML`","ref":"changelog.html#features"},{"type":"extras","title":"0.3.1 (2017-05-07) - Changelog","doc":"#","ref":"changelog.html#0-3-1-2017-05-07"},{"type":"extras","title":"Bugfixes - Changelog","doc":"* use new benchee_json release to circumvent faulty typespec","ref":"changelog.html#bugfixes"},{"type":"extras","title":"0.3.0 (2017-05-07) - Changelog","doc":"Benchee 0.8.0 compatibility, typesepcs, just Elixir 1.3+ and add missing applications.","ref":"changelog.html#0-3-0-2017-05-07"},{"type":"extras","title":"0.2.0 (2017-04-23) - Changelog","doc":"This release splits up the resulting HTML into multiple files, so that it isn't just one long HTML file and also for performance as drawing the graphs with lots of data points seems to be quite taxing on the browser.\n\n#","ref":"changelog.html#0-2-0-2017-04-23"},{"type":"extras","title":"Features - Changelog","doc":"* Instead of one huge HTML multiple files are generated:\n  * An index page\n  * a job comparison page per input\n  * a detail view page per job per input","ref":"changelog.html#features"},{"type":"extras","title":"Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Code of Conduct","doc":"In the interest of fostering an open and welcoming environment, we as\ncontributors and maintainers pledge to making participation in our project and\nour community a harassment-free experience for everyone, regardless of age, body\nsize, disability, ethnicity, gender identity and expression, level of experience,\nnationality, personal appearance, race, religion, or sexual identity and\norientation.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Code of Conduct","doc":"Examples of behavior that contributes to creating a positive environment\ninclude:\n\n* Using welcoming and inclusive language\n* Being respectful of differing viewpoints and experiences\n* Gracefully accepting constructive criticism\n* Focusing on what is best for the community\n* Showing empathy towards other community members\n\nExamples of unacceptable behavior by participants include:\n\n* The use of sexualized language or imagery and unwelcome sexual attention or\nadvances\n* Trolling, insulting/derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or electronic\n  address, without explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Our Responsibilities - Code of Conduct","doc":"Project maintainers are responsible for clarifying the standards of acceptable\nbehavior and are expected to take appropriate and fair corrective action in\nresponse to any instances of unacceptable behavior.\n\nProject maintainers have the right and responsibility to remove, edit, or\nreject comments, commits, code, wiki edits, issues, and other contributions\nthat are not aligned to this Code of Conduct, or to ban temporarily or\npermanently any contributor for other behaviors that they deem inappropriate,\nthreatening, offensive, or harmful.","ref":"code_of_conduct.html#our-responsibilities"},{"type":"extras","title":"Scope - Code of Conduct","doc":"This Code of Conduct applies both within project spaces and in public spaces\nwhen an individual is representing the project or its community. Examples of\nrepresenting a project or community include using an official project e-mail\naddress, posting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event. Representation of a project may be\nfurther defined and clarified by project maintainers.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported by contacting the project team at pragtob@gmail.com (sorry, just me for now). All\ncomplaints will be reviewed and investigated and will result in a response that\nis deemed necessary and appropriate to the circumstances. The project team is\nobligated to maintain confidentiality with regard to the reporter of an incident.\nFurther details of specific enforcement policies may be posted separately.\n\nProject maintainers who do not follow or enforce the Code of Conduct in good\nfaith may face temporary or permanent repercussions as determined by other\nmembers of the project's leadership.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Attribution - Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4,\navailable at [http://contributor-covenant.org/version/1/4][version]\n\n[homepage]: http://contributor-covenant.org\n[version]: http://contributor-covenant.org/version/1/4/","ref":"code_of_conduct.html#attribution"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2016 Tobias Pfeiffer\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# benchee_html [![Hex Version](https://img.shields.io/hexpm/v/benchee_html.svg)](https://hex.pm/packages/benchee_html) [![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/benchee_html/) [![CI](https://github.com/bencheeorg/benchee_html/actions/workflows/main.yml/badge.svg)](https://github.com/bencheeorg/benchee_html/actions/workflows/main.yml) [![Coverage Status](https://coveralls.io/repos/github/bencheeorg/benchee_html/badge.svg?branch=main)](https://coveralls.io/github/bencheeorg/benchee_html?branch=main) [![Total Download](https://img.shields.io/hexpm/dt/benchee_html.svg)](https://hex.pm/packages/benchee_html) [![License](https://img.shields.io/hexpm/l/benchee_html.svg)](https://github.com/bencheeorg/benchee_html/blob/master/LICENSE)\n\nFormatter for [benchee](//github.com/PragTob/benchee) to produce some standalone HTML with nice graphs, a data table etc. from your benchee benchmarking results :) Also allows you to export PNG images, the graphs are also somewhat explorable thanks to [plotly.js](https://plot.ly/javascript/)!\n\nTo get a taste of what this is like you can check out an [online example report](http://www.pragtob.info/benchee/README/results_comparison.html) or look at this little screenshot:\n\n![ips](http://www.pragtob.info/benchee/images/report.png)\n\nIt not only generates HTML but also assets and into the same folder. You can just take it and drop it on your server, github pages or public dropbox directory if you want it to be accessible to someone else :)","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"Add `:benchee_html` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:benchee_html, \"~> 1.0\", only: :dev}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Overview","doc":"Just use it as a formatter for [benchee](https://github.com/PragTob/benchee):\n\n```elixir\nlist = Enum.to_list(1..10_000)\nmap_fun = fn(i) -> [i, i * i] end\n\nBenchee.run(%{\n  \"flat_map\"    => fn -> Enum.flat_map(list, map_fun) end,\n  \"map.flatten\" => fn -> list |> Enum.map(map_fun) |> List.flatten end\n},\n  formatters: [\n    Benchee.Formatters.HTML,\n    Benchee.Formatters.Console\n  ]\n  # override defaults:\n  # formatters: [{Benchee.Formatters.HTML, file: \"output/my.html\", auto_open: false}]\n)\n```\n\nThe report index page will be written to `\"benchmarks/output/results.html\"` and opened in your standard browser automatically. Of course you can also optionally specify a tuple of `{Module, options}` to specify a different destination for the reports: `[{Benchee.Formatters.HTML, file: \"your_file.html\"}]`. Auto open behaviour can be overridden in the same manner: `html: [{Benchee.Formatters.HTML, auto_open: false}]`\n\nOf course it also works with multiple inputs, in that case one file per input is generated:\n\n```elixir\nmap_fun = fn(i) -> [i, i * i] end\n\nBenchee.run(%{\n  \"flat_map\"    => fn(list) -> Enum.flat_map(list, map_fun) end,\n  \"map.flatten\" => fn(list) -> list |> Enum.map(map_fun) |> List.flatten end\n},\n  formatters: [\n    {Benchee.Formatters.HTML, file: \"samples_output/my.html\"},\n    Benchee.Formatters.Console\n  ],\n  time: 7,\n  warmup: 3,\n  inputs: %{\n    \"Smaller List\" => Enum.to_list(1..1_000),\n    \"Bigger List\"  => Enum.to_list(1..100_000),\n  }\n)\n\n```\n\nWhen you hover the graphs in the HTML report, quite some plotly.js controls and links appear with which you can navigate in the graph and more.\n\nBe aware, that currently when too many samples are recorded (> 100_000 usually) rendering might break as plotly can't handle all that data. See [this issue](https://github.com/PragTob/benchee_html/issues/3) on how to quick fix it and what could be done in the future.","ref":"readme.html#usage"},{"type":"extras","title":"PNG image export/download - Overview","doc":"When you hover the graph the controls appear and the left most of those is a camera and says \"Download plot as png\" - and it does what you'd expect. Refer to the image below if you need more guidance :)\n\n![download](http://www.pragtob.info/benchee/images/download.png)","ref":"readme.html#png-image-export-download"},{"type":"extras","title":"A look at graphs - Overview","doc":"In the wiki there is a page [providing an overview of the differnt chart types benchee_html produces](https://github.com/PragTob/benchee_html/wiki/Chart-Types).\n\nFor the ones that just want to scroll through, here they are once more.\n\n#","ref":"readme.html#a-look-at-graphs"},{"type":"extras","title":"IPS Bar Chart - Overview","doc":"![ips](http://www.pragtob.info/benchee/images/ips.png)\n\n#","ref":"readme.html#ips-bar-chart"},{"type":"extras","title":"Run Time Boxplot - Overview","doc":"![boxplot](http://www.pragtob.info/benchee/images/boxplot.png)\n\n#","ref":"readme.html#run-time-boxplot"},{"type":"extras","title":"Run Time Histogram - Overview","doc":"![histo](http://www.pragtob.info/benchee/images/histogram.png)\n\n\n#","ref":"readme.html#run-time-histogram"},{"type":"extras","title":"Raw run times - Overview","doc":"![raw_run_times](http://www.pragtob.info/benchee/images/raw_run_times.png)","ref":"readme.html#raw-run-times"},{"type":"extras","title":"Contributing - Overview","doc":"Contributions to benchee_html are very welcome! Bug reports, documentation, spelling corrections, whole features, feature ideas, bugfixes, new plugins, fancy graphics... all of those (and probably more) are much appreciated contributions!\n\nPlease respect the [Code of Conduct](//github.com/PragTob/benchee_html/blob/master/CODE_OF_CONDUCT.md).\n\nYou can get started with a look at the [open issues](https://github.com/PragTob/benchee_html/issues).\n\nA couple of (hopefully) helpful points:\n\n* Feel free to ask for help and guidance on an issue/PR (\"How can I implement this?\", \"How could I test this?\", ...)\n* Feel free to open early/not yet complete pull requests to get some early feedback\n* When in doubt if something is a good idea open an issue first to discuss it\n* In case I don't respond feel free to bump the issue/PR or ping me on other places","ref":"readme.html#contributing"},{"type":"extras","title":"Development - Overview","doc":"* `mix deps.get` to install dependencies\n* `mix test` to run tests\n* `mix credo` or `mix credo --strict` to find code style problems (not too strict with the 80 width limit for sample output in the docs)","ref":"readme.html#development"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2016 Tobias Pfeiffer\n\nThis library is released under the MIT License. See the [LICENSE.md](./LICENSE.md) file\nfor further details.","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}